<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();
?>

<?php
require_once 'PEAR.php';
require_once 'Services/Amazon.php';
		
		
		$assid = $this->params->get('params.assid', 0);
		$country = $this->params->get('params.country');
		$public_key = $this->params->get('params.public_key', 0);
		$private_key = $this->params->get('params.private_key', 0);
		$image = $this->params->get('params.image', 0);
		$buy_now = $this->params->get('params.buy_now', 0);
		$costumerreviews = $this->params->get('params.costumerreviews', 0);
		$similar = $this->params->get('params.similar', 0);
		$debug = $this->params->get('params.debug', 0);
		$cache = $this->params->get('params.cache', 3600);
		
		$amazon = new Services_Amazon($public_key, $private_key, $assid);
		$amazon->setLocale($country);
		$amazon->setCache('file', array('cache_dir' => 'tmp/', 'filename_prefix' => 'amazon_'));
		$amazon->setCacheExpire($cache);
		$options['ResponseGroup'] = 'Large';
		if ($this->value['mode'] == "lookup") {
			$xml = $amazon->ItemLookup($this->value['asin'], $options);
		}
		if ($this->value['mode'] == "search") {
			$options['Keywords'] = $this->value['asin'];
			$xml = $amazon->ItemSearch($this->value['category'], $options);
		}
				

	if ($debug==1) {
		echo '<p>REST request:<br/>';
		echo '<a href="' . htmlspecialchars($amazon->getLastUrl()) . '" target="_blank">' .
    	 ereg_replace('&amp;', '<br/>&amp;', htmlspecialchars($amazon->getLastUrl())) . '</a></p>';

		echo '<p>Processing Time:'.$amazon->getProcessingTime() . 'seconds'.'</p>';
		echo '<p>Result:</p>';
	    echo '<pre>';
	    var_dump($xml);
	    echo '</pre>';
		
	} //end if ($debug)		


$out = array(); // initalise var $out
// *** Report Errors ****/////
//Verify a successful request
if(PEAR::isError($xml)){
	$out = "<p class='error'>".$xml->message."</p>";
	return $out;
}
// **** END ERRORS ***//
//Build the HTML
if (!empty($xml['Item'])) {	
foreach($xml['Item'] as $item){

		$imgwidth = $item['LargeImage']['Width']['_content']+10;
		$imgheight = $item['LargeImage']['Height']['_content']+10;
		
		$authors = array();
		$artists = array();
		if (!empty($item['ItemAttributes']['Author'])) {			
				foreach($item['ItemAttributes']['Author'] as $author){
					$authors[] = $author;
				} 
			$authors_out = implode(", ",$authors);
		} else {$authors_out = '';}
		if (!empty($item['ItemAttributes']['Artist'])) {			
			$artists_out = $item['ItemAttributes']['Artist'];
		} else {$artists_out = '';}
		
		$out[] = "<h4>" . $item['ItemAttributes']['Title']. "</h4>";
	
		$out[] = "<div style='float:right;width:220px;margin:0px 0px 50px 50px;'>";
		if($image == 1) {
			$out[] = "<img src='". $item['MediumImage']['URL']."' alt='". $item['ItemAttributes']['Title']." :: ".$authors_out.$artists_out."' />"; 
		}
		if($image == 2) {
			$out[] = "<a rel='".$item['ASIN']."' class='jcepopup' target='_blank' title='". $item['ItemAttributes']['Title']." :: ".$authors_out.$artists_out."' href='". $item['LargeImage']['URL']."'><img alt='". $item['ItemAttributes']['Title']." :: ".$authors_out.$artists_out."' src='". $item['MediumImage']['URL']."' /></a>";
		}
		if($image == 3) {
			$out[] = "<a rel='rokbox[$imgwidth $imgheight](".$item['ASIN'].")' title='". $item['ItemAttributes']['Title']." :: ".$authors_out.$artists_out."' href='". $item['LargeImage']['URL']."'><img src='". $item['MediumImage']['URL']."' alt='". $item['ItemAttributes']['Title']." :: ".$authors_out.$artists_out."' /></a>"; 
		}
	if(!empty($item['ImageSets']['ImageSet']) && isset($item['ImageSets']['ImageSet'][0]['Category'])) {	
		$out[] = "<p>";
		foreach($item['ImageSets']['ImageSet'] as $imageset){
			
				if($image == 2) {
					$out[] = "<a rel='".$item['ASIN']."' class='jcepopup' target='_blank' title='".$item['ItemAttributes']['Title']."' href='". $imageset['LargeImage']['URL']."'><img alt='' src='". $imageset['SwatchImage']['URL']."' /></a>";
				}
				if($image == 3) {
					$out[] = "<a rel='rokbox[$imgwidth $imgheight](".$item['ASIN'].")' title='".$item['ItemAttributes']['Title']."' href='". $imageset['LargeImage']['URL']."'><img alt='' src='". $imageset['SwatchImage']['URL']."' /></a>"; 
				}

		}
		$out[] = "</p>";
	}
		if($item['Offers']['Offer']['OfferListing']['Price']['FormattedPrice']) {			  
			  $out[] = "<br/><b>". JText::_('Price').": ".$item['Offers']['Offer']['OfferListing']['Price']['FormattedPrice'] . "</b>";
			}
		if($buy_now == 1) {
					$out[] = "<br/><br/><a href='". $item['Offers']['MoreOffersUrl']."&condition=new' target='_blank' class='icon-external-link btn-large btn'> ".JText::_('Buy')."</a>";
				}
		if($item['Offers']['TotalOffers'] > 0) {
			$out[] = "<br />". $item['Offers']['Offer']['OfferListing']['Availability'] ."<br />";	
		} 
		if($item['OfferSummary']['TotalNew'] > 0) {		
				$out[] = "<br/><br/><a href='". $item['Offers']['MoreOffersUrl']."&condition=new' target='_blank' class='icon-external-link'> ".$item['OfferSummary']['TotalNew'] ." ". JText::_('Lowest Price').":</a> ".$item['OfferSummary']['LowestNewPrice']['FormattedPrice'] . "";
			}
		if($item['OfferSummary']['TotalUsed'] > 0) {		
				$out[] = "<br/><a href='". $item['Offers']['MoreOffersUrl']."&condition=used' target='_blank' class='icon-external-link'> ". $item['OfferSummary']['TotalUsed'] ." ". JText::_('Lowest Used Price').":</a> ".$item['OfferSummary']['LowestUsedPrice']['FormattedPrice'] ."";
			}
		if($item['OfferSummary']['TotalCollectible'] > 0) {		
				$out[] = "<br/><a href='". $item['Offers']['MoreOffersUrl']."&condition=collectible' target='_blank' class='icon-external-link'> ". $item['OfferSummary']['TotalCollectible'] ." ". JText::_('Lowest Collectible Price').":</a> ".$item['OfferSummary']['LowestCollectiblePrice']['FormattedPrice'] ."";
			}
					
		$out[] = "</div>";
		
		if (!empty($authors_out)) {
			$out[] = JText::_('Author').": ".$authors_out;
		}
		if (!empty($artists_out)) {
				$out[] = "". JText::_('Artist').": ".$artists_out."<br />";
		}
		$out[]  = "<br/>". JText::_('Label').": ".$item['ItemAttributes']['Label'];
		$out[]  = "<br/>". JText::_('Binding').": ".$item['ItemAttributes']['Binding'];
		
		if (!empty($item['ItemAttributes']['Format'])) {
			$out[]  = "<br/>". JText::_('Format').": ".$item['ItemAttributes']['Format'];
		}
		if (!empty($item['ItemAttributes']['AspectRatio'])) {
			$out[]  = "<br/>". JText::_('AspectRatio').": ".$item['ItemAttributes']['AspectRatio'];
		}
		if (!empty($item['ItemAttributes']['Size'])) {
			$out[]  = "<br/>". JText::_('Size').": ".$item['ItemAttributes']['Size'];
		}
		if (!empty($item['ItemAttributes']['Color'])) {
			$out[]  = "<br/>". JText::_('Color').": ".$item['ItemAttributes']['Color'];
		}
		if (!empty($item['ItemAttributes']['Manufacturer'])) {
			$out[]  = "<br/>". JText::_('Manufacturer').": ".$item['ItemAttributes']['Manufacturer'];
		}
		
		$out[]  =  "<br/>". JText::_('EAN').": ".$item['ItemAttributes']['EAN'];
		if (!empty($item['ItemAttributes']['ISBN'])) {
			$out[]  =  "<br/>". JText::_('ISBN').": ".$item['ItemAttributes']['ISBN'];
		}

		if (!empty($item['ItemAttributes']['Languages']['Language'])) {
			$out[] = "<br/>". JText::_('Language').": ";
						foreach($item['ItemAttributes']['Languages']['Language'] as $language){
							$out[] = $language['Name'].", ".$language['Type']."; ";	
						}
		}
		if (!empty($item['ItemAttributes']['Creator'])) {
				foreach($item['ItemAttributes']['Creator'] as $creator){
					$out[] = "<br />".$creator['Role'].": ".$creator['_content'];							
				}	
		}
 		
		if (!empty($item['ItemAttributes']['RunningTime'])) {
			$out[] = "<br />".$item['ItemAttributes']['RunningTime']['Units'].": ".$item['ItemAttributes']['RunningTime']['_content'];		
		}
		if (!empty($item['ItemAttributes']['NumberOfDiscs'])) {
			$out[] = "<br/>". JText::_('NumberOfDiscs').": ".$item['ItemAttributes']['NumberOfDiscs']."";
		}
		if (!empty($item['ItemAttributes']['NumberOfItems'])) {
			$out[] = "<br/>". JText::_('NumberOfItems').": ".$item['ItemAttributes']['NumberOfItems']."";
		}
		if (!empty($item['ItemAttributes']['NumberOfPages'])) {
			$out[] = "<br/>". JText::_('NumberOfPages').": ".$item['ItemAttributes']['NumberOfPages']."";
		}
		$out[] =  "<br/>". JText::_('Studio').": " .$item['ItemAttributes']['Studio']."";
		if (!empty($item['ItemAttributes']['PublicationDate'])) {
			$out[] =  "<br/>". JText::_('Publication Date').": " . date('d.m.Y', strtotime($item['ItemAttributes']['PublicationDate'])) ."";
		}
		if (!empty($item['ItemAttributes']['ReleaseDate'])) {
			$out[] =  "<br/>". JText::_('Publication Date').": " . date('d.m.Y', strtotime($item['ItemAttributes']['ReleaseDate'])) ."";
		}
		$out[] =  "<br/>". JText::_('SalesRank').": " . number_format($item['SalesRank'], '0', '', '.') . "";
		
		if (!empty($item['ItemAttributes']['Feature'])) {
			$out[] =  "<ul>";
			foreach($item['ItemAttributes']['Feature'] as $feature){
				$out[] =  "<li>" .$feature. "</li>";
			}
			$out[] =  "</ul>";
		}
		if (!empty($item['Tracks']['Disc'])) {
			$out[] =  "<h4>Tracks</h4>";
			if(isset($item['Tracks']['Disc']['Number'])) {
				$out[] = "<h5>CD ".$item['Tracks']['Disc']['Number']."</h5>";
				 foreach($item['Tracks']['Disc']['Track'] as $track){
							$out[] = $track['Number'].". ".$track['_content']."<br />";
						}
			} else {
				foreach($item['Tracks']['Disc'] as $disc){
					$out[] = "<h5>CD ".$disc['Number']."</h5>";						
						foreach($disc['Track'] as $track){
							$out[] = $track['Number'].". ".$track['_content']."<br />";
						}
				}
			}
		}
		$out[] =  "<br /><br/><a href='" . $item['DetailPageURL'] . "' target='_blank' class='icon-external-link'> " . JText::_('Amazon Product Details'). "</a>";
		$links = $item['ItemLinks']['ItemLink'];
		foreach($links as $link){
 			  $out[] = "<br/><a href='" . $link['URL'] . "' target='_blank' class='icon-external-link'> " . JText::_($link['Description']). "</a>";
			}
		
		if(!empty($item['EditorialReviews']['EditorialReview'])) {
			$out[] = "<br/><br/><b>".JText::_($item['EditorialReviews']['EditorialReview'][0]['Source'])."</b><br/>".$item['EditorialReviews']['EditorialReview'][0]['Content'] ."";
		}
		

		if($costumerreviews==1 && $item['CustomerReviews']['HasReviews']=="true"){
			if($image == 0 || $image == 1) {
			$out[] = "<iframe src=".$item['CustomerReviews']['IFrameURL']." width=\"100%\" height=\"400\" name=\"Amazon Reviews\">";
			$out[] = "<p>Ihr Browser kann leider keine eingebetteten Frames anzeigen:";
			$out[] = "Sie k&ouml;nnen die eingebettete Seite &uuml;ber den folgenden Verweis aufrufen: ";
			$out[] = "<a href=\"".$item['CustomerReviews']['IFrameURL']."\">". JText::_('COSTUMER REVIEWS')."</a></p>";
			$out[] = "</iframe>";
			}
			if($image == 2) {
			$out[] = "<h4><a class=\"jcepopup\" rel=\"caption[".$item['ItemAttributes']['Title']." :: ". JText::_('COSTUMER REVIEWS')."];width[800];height[600]\" href=\"".$item['CustomerReviews']['IFrameURL']."\">". JText::_('COSTUMER REVIEWS')."</a></h4>";
			}
			if($image == 3) {
			$out[] = "<h4><a rel=\"rokbox[800 600]\" title=\"".$item['ItemAttributes']['Title']." :: ". JText::_('COSTUMER REVIEWS')."\" href=\"".$item['CustomerReviews']['IFrameURL']."\">". JText::_('COSTUMER REVIEWS')."</a></h4>";
			}
		}

	
	// Similar Products
	if ($similar==1) {
		
		$out[] = getSimiliars($item['ASIN'], $public_key, $private_key, $assid, $country, $image, $debug, $cache);

	} // end (Similar Products)
	
}	// end foreach($xml->Items->Item as $xml->Items->Item)
} // End if(!empty)
	

		$out = implode("\r", $out);
		echo $out;


function getSimiliars($asin, $public_key, $private_key, $assid, $country, $image, $debug, $cache) {
		
	$amazon2 = new Services_Amazon($public_key, $private_key, $assid);
	$amazon2->setLocale($country);
	$amazon2->setCache('file', array('cache_dir' => 'tmp/', 'filename_prefix' => 'amazon_'));
	$amazon2->setCacheExpire($cache);
	$options['ResponseGroup'] = 'Medium';
	$xml2 = $amazon2->SimilarityLookup($asin, $options);
	
		
				
	if ($debug==1) {
		echo '<p>REST request:<br/>';
		echo '<a href="' . htmlspecialchars($amazon2->getLastUrl()) . '" target="_blank">' .
    	 ereg_replace('&amp;', '<br/>&amp;', htmlspecialchars($amazon2->getLastUrl())) . '</a></p>';

		echo '<p>Processing Time:'.$amazon2->getProcessingTime().'</p>';
		echo '<p>Result:</p>';
	    echo '<pre>';
		var_dump($xml2);
	    echo '</pre>';
		
	} //end if ($debug)		
$out = '';
// Report Errors 
if(PEAR::isError($xml2)){
	$out = "<p class='error'>".$xml2->message."</p>";
	return $out;
}
	
			if(!empty($xml2['Item'])) {
				$out .= "<h4>".JText::_('Similar Products')."</h4>";
				$out .= "<p>";
				foreach($xml2['Item'] as $similar){
					$sim_author_out = '';
					$sim_artist_out = '';
					if (!empty($similar['ItemAttributes']['Author'])) {	
						$sim_author = implode(", ", $similar['ItemAttributes']['Author']);						
						$sim_author_out .= "<b><i>".$sim_author."</i></b>&nbsp;";							
					}
					if (!empty($similar['ItemAttributes']['Artist'])) {	
							$sim_artist_out .= "<b><i>".$similar['ItemAttributes']['Artist']."</i></b>&nbsp;";	
					}
					$out .= "<br />";
				if (!empty($similar['SmallImage']['URL']) && !empty($similar['LargeImage']['URL'])) {
					if($image == 1) {
						$out .= "<img src='".$similar['SmallImage']['URL']."' alt='".$similar['ItemAttributes']['Title']." :: ".$sim_author_out.$sim_artist_out."' style='float:left; padding-right:15px;' />\n"; 
					}
					if($image == 2) {
						$out .= "<a class='jcepopup' target='_blank' title='".$similar['ItemAttributes']['Title']." :: ".$sim_author_out.$sim_artist_out."' href='".$similar['LargeImage']['URL']."'><img alt='".$similar['ItemAttributes']['Title']." :: ".$sim_author_out.$sim_artist_out."' src='".$similar['SmallImage']['URL']."' style='float:left; padding-right:15px;' /></a>\n";
					}
					if($image == 3) {
						$out .= "<a rel='rokbox[]' title='".$similar['ItemAttributes']['Title']." :: ".$sim_author_out.$sim_artist_out."' href='".$similar['LargeImage']['URL']."'><img src='".$similar['SmallImage']['URL']."' alt='".$similar['ItemAttributes']['Title']." :: ".$sim_author_out.$sim_artist_out."' style='float:left; padding-right:15px;' /></a>\n"; 
					}
				}
					$out .= "<b><a href='".$similar['DetailPageURL']."' target='_blank' class='icon-external-link'> ".$similar['ItemAttributes']['Title']."</a></b>";
					
					if (!empty($sim_author_out)) {	
						$out .= "<br/><b><i>".$sim_author_out."</i></b>";	
					}
					if (!empty($sim_artist_out)) {	
						$out .= "<br/><b><i>".$sim_artist_out."</i></b>";	
					}
					if (!empty($similar['ItemAttributes']['ListPrice']['FormattedPrice'])) {
						$out .= "<br/>". JText::_('Price').": ".$similar['ItemAttributes']['ListPrice']['FormattedPrice'] . "";
					}
					if (!empty($similar['SalesRank'])) {
					 $out .=  "<br/>". JText::_('SalesRank').": " . number_format($similar['SalesRank'], '0', '', '.') . "";
					}
					$out .= "<br /><br style='clear:both;' />";	
				}
				$out .= "</p>";
				
		} // end if(!empty($similars)
		
	return $out;
}
?>